/var/lib/pcp/testsuite/340 is in pcp-testsuite 4.0.1-1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 | #! /bin/sh
# PCP QA Test No. 340
# PMCD denies all access?
#
# Copyright (c) 1995-2002 Silicon Graphics, Inc. All Rights Reserved.
#
seq=`basename $0`
echo "QA output created by $seq"
# get standard environment, filters and checks
. ./common.product
. ./common.filter
. ./common.check
perl -e "use PCP::PMDA" >/dev/null 2>&1
test $? -eq 0 || _notrun "PCP::PMDA perl module is not installed"
status=1 # failure is the default!
[ -z "$PCP_PMLOGGERCONTROL_PATH" ] && \
PCP_PMLOGGERCONTROL_PATH="$PCP_SYSCONF_DIR/pmlogger/control"
_filter_pminfo()
{
sed \
-e 's/Connection reset by peer/No permission to perform requested operation/' \
-e 's/"'$me'"/"HOST"/g' \
# end
}
# real QA test starts here
me=`_get_fqdn`
_needclean=true
cleanup()
{
if $_needclean
then
_needclean=false
_restore_config $PCP_PMCDCONF_PATH
_change_config pmlogger on
_service pcp restart | _filter_pcp_start
_wait_for_pmcd
_wait_for_pmlogger
fi
if $_chkconfig_pmlogger_on
then
[ -f $tmp.control ] && \
$sudo cp $tmp.control $PCP_PMLOGGERCONTROL_PATH
_service pcp restart | _filter_pcp_start
_wait_for_pmcd
_wait_for_pmlogger
_chkconfig_pmlogger_on=false
fi
$sudo rm -f $tmp.*
exit $status
}
trap "cleanup; exit \$status" 0 1 2 3 15
rm -f $seq.full
# see if unix domain sockets are available (permissions)
_get_libpcp_config
target="localhost"
$unix_domain_sockets && target="unix:"
# real QA test starts here
# disable all pmloggers ...
_chkconfig_pmlogger_on=true
$sudo cp $PCP_PMLOGGERCONTROL_PATH $tmp.control
cat <<End-of-File >$tmp.tmp
# dummy file created by qa/$seq on `date`
# the goal here is to have a controlled primary logger that does
# not make requests to pmcd!
\$version=1.1
LOCALHOSTNAME y n $PCP_LOG_DIR/pmlogger/LOCALHOSTNAME -c /dev/null
End-of-File
$sudo cp $tmp.tmp $PCP_PMLOGGERCONTROL_PATH
#_change_config pmlogger off
_save_config $PCP_PMCDCONF_PATH
other=`./getpmcdhosts -n 1 -L -v 'pcp>=2' 2>$tmp.err`
if [ -z "$other" ]
then
# Unable to find remote PCP 2.x host
cat $tmp.err >$seq.notrun
exit
fi
echo "other=$other" >>$seq.full
list=`_all_hostnames $other`
if [ -z "$list" ]
then
echo "Error: failed to expand hostnames for other=\"$other\""
exit
fi
echo "list=$list" >>$seq.full
cat >$tmp.access <<End-Of-File
[access]
disallow $list : all;
allow * : all;
End-Of-File
sed -e '/\[access]/q' $PCP_PMCDCONF_PATH.$seq \
| sed -e '/\[access]/d' >$tmp.config
cat $tmp.access >>$tmp.config
$sudo cp $tmp.config $PCP_PMCDCONF_PATH
echo >>$seq.full
echo "---- start pmcd.conf ----" >>$seq.full
cat $PCP_PMCDCONF_PATH >>$seq.full
echo "---- end pmcd.conf ----" >>$seq.full
_service pcp restart | _filter_pcp_start
_wait_for_pmcd 20 $target
_wait_for_pmlogger
echo " checking default access for this host ..."
pminfo -f sample.long.million \
| _filter_pminfo
pmstore sample.write_me 111
echo " checking access for list (should fail)"
ssh -q pcpqa@$other pminfo -h $me -f pmcd.numclients 2>&1 \
| _filter_pminfo
echo "pmcd.log:======="
sed -n <$PCP_PMCDLOG_PATH -e '/endclient/{
s/\[[0-9]*]/[M]/
s/(fd [0-9]*)/(fd N)/
p
}' \
| sort \
| uniq
echo "================"
iplist=`_all_ipaddrs $other`
if [ -z "$iplist" ]
then
echo "Error: failed to expand ip addrs for other=\"$other\""
exit
fi
echo "iplist=$iplist" >>$seq.full
cat >$tmp.access <<End-Of-File
[access]
disallow $iplist : all;
allow * : all;
End-Of-File
sed -e '/\[access]/q' $PCP_PMCDCONF_PATH.$seq \
| sed -e '/\[access]/d' >$tmp.config
cat $tmp.access >>$tmp.config
$sudo cp $tmp.config $PCP_PMCDCONF_PATH
echo >>$seq.full
echo "---- start pmcd.conf ----" >>$seq.full
cat $PCP_PMCDCONF_PATH >>$seq.full
echo "---- end pmcd.conf ----" >>$seq.full
_service pcp restart | _filter_pcp_start
_wait_for_pmcd
_wait_for_pmlogger
echo " checking default access for this host ..."
pminfo -f sample.long.million
pmstore sample.write_me 444
echo
echo " checking access for iplist (should fail)"
ssh -q pcpqa@$other pminfo -h $me -f pmcd.numclients 2>&1 \
| _filter_pminfo
echo "pmcd.log:======="
sed -n <$PCP_PMCDLOG_PATH -e '/endclient/{
s/\[[0-9]*]/[M]/
s/(fd [0-9]*)/(fd N)/
p
}'
echo "================"
# success, all done
status=0
exit
|